#pragma once

#include "call_state.h"

#include <yandex_io/callkit/calls/call/call_transport.h>

#include <memory>

namespace messenger {

    class CallStateMachine;

    class OutgoingCallCreationFailedState: public CallState {
    public:
        OutgoingCallCreationFailedState(CallTransport::ErrorCode errorCode);
        ~OutgoingCallCreationFailedState();

        void enter(CallStateMachine* machine) override;
        void exit() override;

        std::string toString() const override;

    private:
        CallTransport::ErrorCode errorCode_;
    };

} // namespace messenger
