#pragma once

#include <yandex_io/callkit/rtc/media/sender_state_machine.h>

namespace messenger {
    namespace rtc {

        class SenderStateMachine::CompleteSendingState: public SenderStateMachine::SenderState {
        public:
            explicit CompleteSendingState(SenderStateMachine* machine);

            static const std::string NAME;

            const std::string& name() const override {
                return NAME;
            }

            void enter() override;

            void exit() override;

        private:
            std::string requestId_;
            MediatorApi::MessageSubscription subscription_;
        };

    } // namespace rtc
} // namespace messenger
