OWNER(g:yandex_io polikarpov)

LIBRARY()

PEERDIR(
    contrib/restricted/boost
    contrib/deprecated/jsoncpp
    contrib/libs/msgpack
    mssngr/router/lib/protos

    yandex_io/callkit/rtc/media/fake_webrtc_video_engine
    yandex_io/libs/device
    yandex_io/libs/base
    yandex_io/libs/configuration
    yandex_io/libs/cryptography
    yandex_io/libs/http_client
    yandex_io/libs/json_utils
    yandex_io/libs/telemetry
    yandex_io/libs/threading
    yandex_io/callkit/rtc/media/audio_device_module
    yandex_io/libs/websocket
    yandex_io/interfaces/user_config/connector
)

CFLAGS(-Wno-unused-parameter)

SRCS(
    api/create_private_chat_task.cpp
    api/request_user_task.cpp
    api/session_api_request.cpp
    api/session_api_service.cpp
    api/session_api_task.cpp
    api/session_request_factory.cpp
    calls/call/call.cpp
    calls/call/call_holder.cpp
    calls/call/call_transport.cpp
    calls/call/notifier.cpp
    calls/call/request_id.cpp
    calls/call/statemachine/call_ended_state.cpp
    calls/call/statemachine/call_ending_state.cpp
    calls/call/statemachine/call_live_state.cpp
    calls/call/statemachine/call_start_awaiting_state.cpp
    calls/call/statemachine/call_state.cpp
    calls/call/statemachine/call_state_machine.cpp
    calls/call/statemachine/incoming_call_accepting_state.cpp
    calls/call/statemachine/incoming_call_declined_state.cpp
    calls/call/statemachine/incoming_call_declining_state.cpp
    calls/call/statemachine/incoming_call_ringing_state.cpp
    calls/call/statemachine/initial_call_state.cpp
    calls/call/statemachine/outgoing_call_accept_awaiting_state.cpp
    calls/call/statemachine/outgoing_call_creating_state.cpp
    calls/call/statemachine/outgoing_call_creation_failed_state.cpp
    calls/call/statemachine/user_action_dispatcher.cpp
    calls/call/status.cpp
    calls/calling_message_receiver.cpp
    calls/calling_messages_sender.cpp
    calls/calling_service.cpp
    calls/calls_controller.cpp
    calls/calls_controller_provider.cpp
    calls/messenger_call_transport.cpp
    cli/cli.cpp
    connection/client_request_task.cpp
    connection/connection_service.cpp
    connection/dedicated_socket.cpp
    connection/messenger_protocol.cpp
    connection/pushd_socket.cpp
    connection/push_handler.cpp
    connection/request_handler.cpp
    rtc/media/api/mediator_api.cpp
    rtc/media/states/config_applying_state.cpp
    rtc/media/states/config_awaiting_state.cpp
    rtc/media/states/local_answer_creating_state.cpp
    rtc/media/states/local_answer_sending_state.cpp
    rtc/media/states/local_answer_setting_state.cpp
    rtc/media/states/local_offer_creating_state.cpp
    rtc/media/states/local_offer_sending_state.cpp
    rtc/media/states/local_offer_setting_state.cpp
    rtc/media/states/negotiating_state.cpp
    rtc/media/states/peer_connection_broken_state.cpp
    rtc/media/states/peer_connection_creation_failed_state.cpp
    rtc/media/states/peer_connection_creating_state.cpp
    rtc/media/states/peer_connection_established_state.cpp
    rtc/media/states/ready_for_negotiation_state.cpp
    rtc/media/states/remote_answer_receiving_state.cpp
    rtc/media/states/remote_answer_setting_state.cpp
    rtc/media/states/remote_offer_receiving_state.cpp
    rtc/media/states/remote_offer_setting_state.cpp
    rtc/media/states/renegotiation_needed_state.cpp
    rtc/media/states/session_disposed_state.cpp
    rtc/media/states/user_media_acquiring_state.cpp
    rtc/media/states/waiting_for_connection_state.cpp
    rtc/media/states/candidates_sending_state.cpp
    rtc/media/states/complete_sending_state.cpp
    rtc/media/states/complete_sent_state.cpp
    rtc/media/states/waiting_for_candidates_state.cpp
    rtc/media/candidates_sender.cpp
    rtc/media/device_info.cpp
    rtc/media/media_session.cpp
    rtc/media/media_session_impl.cpp
    rtc/media/media_session_factory.cpp
    rtc/media/redirect_peer_connection_observer.cpp
    rtc/media/sender_state_machine.cpp
    rtc/media/session_state_machine.cpp
    rtc/media/state_machine.cpp
    rtc/media/stats_sender.cpp
    rtc/media/transport.cpp
    rtc/utils/network_monitor.cpp
    rtc/utils/timer.cpp
    rtc/utils/timer_factory.cpp
    rtc/utils/utils.cpp
    session/session.cpp
    session/session_impl.cpp
    session/session_provider.cpp
    session/session_service.cpp
    session/session_settings.cpp
    storage/data_storage.cpp
    util/async_service.cpp
    util/async_task.cpp
    util/cancelable.cpp
    util/loop_thread.cpp
    util/murmur_hash2.cpp
    xiva/socket_api.cpp
    xiva/transport.cpp
)

END()

RECURSE(
    messenger_tool
    rtc/media/audio_device_module
    rtc/media/fake_webrtc_video_engine
    util
)
