#pragma once

#include <yandex_io/capabilities/device_state/device_state_capability.h>
#include <yandex_io/sdk/private/remoting/i_remote_object.h>
#include <yandex_io/sdk/private/remoting/i_remoting_registry.h>

namespace YandexIO {

    class DeviceStateCapabilityHost: public DeviceStateCapability, public IRemoteObject {
    public:
        DeviceStateCapabilityHost(std::shared_ptr<quasar::ICallbackQueue> worker, std::weak_ptr<IRemotingRegistry> remotingRegistry);
        void init();

    private:
        // IRemoteObject
        void handleRemotingMessage(
            const quasar::proto::Remoting& message,
            std::shared_ptr<IRemotingConnection> connection) override;
    };

} // namespace YandexIO
