#pragma once

#include <array>
#include <string>
#include <unordered_set>

namespace quasar {

    class DirectiveTypes final {
    public:
        static bool contains(const std::string& type);

        static constexpr const char* SERVER_ACTION = "server_action";
        static constexpr const char* LOCAL_ACTION = "local_action";
        static constexpr const char* CLIENT_ACTION = "client_action";

    private:
        static const std::unordered_set<std::string> DIRECTIVE_TYPES;
    };

} /* namespace quasar */
