#pragma once

#include <atomic>
#include <string_view>
#include <thread>

namespace bluez_impl {

    // This disgusting hack is required to keep BT adapter in the advertising mode
    // while LE client is connected.
    // Unfortunately BlueZ does not provide an API for that.
    class LEAdvertisingReenabler {
    public:
        LEAdvertisingReenabler();
        ~LEAdvertisingReenabler();

    private:
        void loop() noexcept;

        void handleEvent(std::string_view frame);
        void enableAdvertising() const;

    private:
        int hci_;
        int stopFd_;

        std::atomic<bool> stopped_ = false;
        std::thread loopThread_;
    };

} // namespace bluez_impl
