# GlagolSDK

GlagolSDK - клиентская часть протокола glagol (двухсторонняя связь устройств по локальной сети).
Существует также GlagolSDK на java (@ashaposhniko) и на swift (@kotovmax) для ПП.

GlagolSDK на C++ сейчас используется только для связи колонок с модулем.

## AvahiBrowseClient

AvahiBrowseClient - синглтон (упс), который с помощью libavahi ищет устройства в локальной сети и дергает колбеки
тех, кто подписался. Поиск начинается после первого подписчика и останавливается, если не осталось ниодного. Клиент
из библиотеки libavahi корректно работает только в единственном экземпляре на устройстве (2 libavahi в разных процессах
тоже не будут работать).

По сути - это просто обертка поверх libavahi.

## Discovery

Discovery - выполняет те же функции, что и AvahiBrowseClient, но уже более специфичные для протокола glagol.
Discovery возвращает данные в нужном формате, можно добавлять фильтры по deviceID, платформам, только привязанным
устройствам (to do). Объектов Discovery уже может быть сколько угодно, они сами подписываются при создании на
AvahiBrowseClient и отписываются при разрушении.

## Connector

Connector - объект для связи с одним устройством. Для работы требует указание url бэкенда и deviceId устройства,
к которому нужно подключиться.

Можно подписаться на изменение стейта коннектора а также на входящие сообщения.

Возможные стейты:
```
[STOPPED, DISCOVERING, REQUESTING_BACKEND, CONNECTING, CONNECTED, DISCONNECTING]
```
Обычно интересен только CONNECTED.

Отправить сообщение можно асинхронно через send, либо синхронно через sendSync.

Формат отправляемого сообщения - json.

## ConversationModel

ConversationModel::RequestPayloadFactory - набор готовых сообщений (своего рода API) cпециально для сценариев
внешних устройств (например ПП) с модулем.

IncomingMessage - формат входящего сообщения.
