#pragma once

#include <set>
#include <string>

namespace quasar {

    struct SpotterTypes {
        // Alice spotters
        static constexpr const char* const ACTIVATION = "activation";
        static constexpr const char* const ADDITIONAL = "additional";
        static constexpr const char* const INTERRUPTION = "interruption";

        // Old navigation spotter
        static constexpr const char* const NAVIGATION_OLD = "navi_old";

        // Command spotters
        static constexpr const char* const GENERAL = "general";
        static constexpr const char* const NAVIGATION = "navi";
        static constexpr const char* const STOP = "stop";
        static constexpr const char* const MUSIC = "music";
        static constexpr const char* const VIDEO = "video";

        static const std::set<std::string> COMMAND_ALL;
    };

} // namespace quasar
