#pragma once

#include <yandex_io/libs/bluetooth/bluetooth.h>
#include <yandex_io/sdk/device_mode_observer.h>
#include <yandex_io/sdk/sdk_interface.h>

#include <memory>

namespace YandexIO {

    class BluetoothModeOnStartSetup: public DeviceModeObserver {
    public:
        explicit BluetoothModeOnStartSetup(std::shared_ptr<Bluetooth> bluetoothImpl);
        void onStartSetup(bool /*isFirstSetup*/) override;
        void onFinishSetup() override;

        void onSoundDataTransferStart() override {
        }
        void onConnectingToNetwork() override {
        }
        void onSetupError() override {
        }
        void onConfigureSuccessUpdate(ConfigurationSuccessState /*configurationSuccessState*/) override {
        }

    private:
        std::shared_ptr<Bluetooth> bluetoothImpl_;
    };

} // namespace YandexIO
