#pragma once

#include <yandex_io/modules/equalizer_controller/dispatcher/equalizer_dispatcher.h>

#include <yandex_io/sdk/sdk_interface.h>

#include <memory>

namespace YandexIO {

    class GStreamerEqualizerDispatcher: public EqualizerDispatcher {
    public:
        explicit GStreamerEqualizerDispatcher(std::weak_ptr<SDKInterface> sdk);
        void setUserConfig(EqualizerConfig config) override;
        void setSmartConfig(EqualizerConfig config) override;

        BandsConfiguration getFixedBandsConfiguration() const override;

    private:
        void setConfig(EqualizerConfig config);

    private:
        const std::weak_ptr<SDKInterface> sdk_;
    };

} // namespace YandexIO
