#pragma once

#include <yandex_io/modules/geolocation/geolocation.h>
#include <yandex_io/modules/geolocation/interfaces/location.h>
#include <yandex_io/modules/geolocation/interfaces/timezone.h>
#include <yandex_io/sdk/sdk_interface.h>

#include <memory>

namespace YandexIO {

    class GeoSDKSetter: public Geolocation::IListener {
    public:
        GeoSDKSetter(std::shared_ptr<SDKInterface> sdk);

        void onLocationChanged(const Location& location) override;

        void onTimezoneChanged(const Timezone& timezone) override;

    private:
        const std::shared_ptr<SDKInterface> sdk_;
    };

} // namespace YandexIO
