#pragma once

#include <yandex_io/sdk/sdk_interface.h>

#include <optional>
#include <string>

namespace YandexIO {

    class VoiceAssistantBlocker {
    public:
        VoiceAssistantBlocker(std::shared_ptr<SDKInterface> sdk, std::string module, std::optional<std::string> errorSound = std::nullopt);

        void block();

        void unblock();

    private:
        const std::shared_ptr<SDKInterface> sdk_;
        const std::string module_;
        const std::optional<std::string> errorSound_;
    };

} // namespace YandexIO
